#!/bin/bash
REPERTOIRE='/var/sauvegardes'
VERSION=`cat /etc/eole/version`
MODULE=`echo $VERSION | cut -d '-' -f 1`

. ParseDico

#monté plusieurs fois ...
demontage(){
    #monté plusieurs fois ...
    cpt=`mount |grep $REPERTOIRE -c`
    if [ "$cpt" != 0 ]
    then
	for i in `seq $cpt`
	do
            echo "Démontage de $REPERTOIRE"
	    /bin/umount $REPERTOIRE > /dev/null 2>&1
        done
    fi
}

resto_dist(){
    echo "Nom NETBIOS de la station de sauvegarde Bacula"
    read pc_distant
    echo "Adresse IP de la station de sauvegarde Bacula"
    read ip_pc_distant
    echo "Nom du partage"
    read partage
    echo "Nom de l'utilisateur sinon rien"
    read user
    echo "Mot de passe sinon rien"
    read pass
    umount $REPERTOIRE &>/dev/null
    if [ -z $user ]
    then
    	mount -t smbfs -o username="''",password="''",ip=$ip_pc_distant //$pc_distant/$partage $REPERTOIRE
    else
    	mount -t smbfs -o username="$user",password="$pass",ip=$ip_pc_distant //$pc_distant/$partage $REPERTOIRE

    fi
    if [ $? -ne 0 ]
    then
    	echo "Erreur : Montage $pc_distant Impossible"
    	exit 1
    fi
}

resto_usb(){
    echo "Quel est le chemin d'accès au périphérique (ex. : /dev/usb) ?"
    read periph_usb
    mount $periph_usb $REPERTOIRE
    if [ $? -ne 0 ]
    then
	echo "Erreur : Montage $periph_usb Impossible (USB)"
        exit 1
    fi
}

resto_scribe(){
    # restauration spécifique LDAP
    echo -e "restore FileSet=Complete Client=127.0.0.1-fd select current yes file=/home/sauv_ldap.ldif done\n1\n"|bconsole -c /etc/bacula/bconsole.conf
    # restauration spécifique MySQL
    echo -e "restore FileSet=Complete Client=127.0.0.1-fd select current yes file=/home/sauv_mysql.sql done\n2\n"|bconsole -c /etc/bacula/bconsole.conf
    # on ne veut pas restaurer LDAP et MySQL
    echo -e "restore FileSet=Complete Client=127.0.0.1-fd select current all yes\ncd home\nunmark sauv_ldap.ldif\nunmark sauv_mysql.sql\ndone\n3\n"|bconsole -c /etc/bacula/bconsole.conf
}

resto_horus(){
    # restauration spécifique LDAP
    echo -e "restore FileSet=Complete Client=127.0.0.1-fd select current yes file=/data/home/sauv_ldap.ldif done\n1\n"|bconsole -c /etc/bacula/bconsole.conf
    # restauration spécifique MySQL
    if [ "$mysql" != "non" ]
    then
	    echo -e "restore FileSet=Complete Client=127.0.0.1-fd select current yes file=/data/home/sauv_mysql.sql done\n2\n"|bconsole -c /etc/bacula/bconsole.conf
    fi
    # on ne veut pas restaurer LDAP et MySQL
    echo -e "restore FileSet=Complete Client=127.0.0.1-fd select current all yes\ncd data\ncd home\nunmark sauv_ldap.ldif\nunmark sauv_mysql.sql\ndone\n3\n"|bconsole -c /etc/bacula/bconsole.conf
}

resto_eclair(){
    echo -e "restore FileSet=Complete Client=127.0.0.1-fd select current all yes\ndone\n1\n"|bconsole -c /etc/bacula/bconsole.conf
}

demontage
echo "Type de support ("distant" ou "usb"):"
read type_support
if [ "$type_support" == "distant" ]
then
    resto_dist
elif [ "$type_support" == "usb" ]
then
    resto_usb
else
    echo "Mauvais type de support \"$type_support\""
    exit 1
fi
# ré-initialisation de la base
/etc/init.d/bacula-director stop
rm -f /var/lib/bacula/bacula.db
/usr/bin/sqlite3 /var/lib/bacula/bacula.db < $REPERTOIRE/$VERSION-bacula.sql
/etc/init.d/bacula-director start
sleep 3

if [ $MODULE == "horus" ]
then
    resto_horus
elif [ $MODULE == "scribe" ]
then
    resto_scribe
elif [ $MODULE == "eclair" ]
then
    resto_eclair
else
    echo Module $MODULE inconnu
    exit 1
fi

# affichage du log
echo "######################################################"
echo "Patientez ...."
echo ""
touch /var/log/bacula/bacula.log
tail -f /var/log/bacula/bacula.log -n0

